隐私偏好

必要功能

用于安全验证和网站基本功能。

始终启用

可选的使用分析

允许 PostHog 用量分析吗?可随时在页脚更改选择。

同时允许在此公开网站上录制会话回放

回放显示公开页面和交互,输入内容及私密内容会被遮蔽。App 回放需要另行选择。

需先开启分析;网站操作回放默认关闭。

浏览器分析选择不会开启账户分析。

仅在使用时加载搜索。在下方浏览所有类别。

研究及附来源简报

更新研究构想

使用 expected_revision 和 mutation_id 取代 Research 构想;过时编辑会发生冲突。需要 agent:research。

POST /research-api/ideas/update

契约审核日期: · sha256:ab393e91e9b7f18a

概览

使用 expected_revision 和 mutation_id 取代 Research 构想;过时编辑会发生冲突。需要 agent:research。

成功 HTTP 响应可能表示请求已接受,并非已完成。背景工作请存储返回 ID,持续检查同一操作直到完成。已排程或已接受的帖子,只有平台确认后才算已发布;客户端逾时无法证明结果。

验证与权限

接受的凭证类别
user_session, delegated_oauth, personal_access_token
委派能力
agent:research
最低工作区角色
editor
访问范围
此用户有权访问的资源
需要所有工作区同意
否
变更状态
是
操作完成时
committed Research resource version; no provider action

令牌只能使用其所有者持有的权利。每次请求会检查工作区成员资格、资源拥有权、所选工作区及已授予能力。core 与 full 配置只变更显示的工具,不会授予访问权限。

请求字段

「必填」是指在其父对象及所选分支内必填。必填子字段不会使可选父对象变成必填。下列规则与字段名称均复制自契约。

请求字段
字段 / 分支类型 / 必填约束
$object在父对象中必填
  • additionalProperties: false
workspace_idstring在父对象中必填
  • format: "uuid"
  • pattern: "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
mutation_idstring在父对象中必填
  • format: "uuid"
  • pattern: "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
idstring在父对象中必填
  • format: "uuid"
  • pattern: "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
expected_revisioninteger在父对象中必填
  • maximum: 9007199254740991
  • exclusiveMinimum: 0
contentobject在父对象中必填
  • additionalProperties: false
content.titlestring在父对象中必填
  • minLength: 1
  • maxLength: 200
content.notesstring在父对象中必填
  • maxLength: 10000
content.audiencestring在父对象中必填
  • maxLength: 2000
content.anglestring在父对象中必填
  • maxLength: 2000
content.tagsarray在父对象中必填
  • maxItems: 20
content.tags[]string可选/项目
  • minLength: 1
  • maxLength: 60
content.evidencearray在父对象中必填
  • maxItems: 500
content.evidence[]object可选/项目
  • additionalProperties: false
content.evidence[].evidence_idstring在父对象中必填
  • format: "uuid"
  • pattern: "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
content.evidence[].revisioninteger在父对象中必填
  • maximum: 9007199254740991
  • exclusiveMinimum: 0
content.project_idstring | null在父对象中必填—
content.project_idanyOf 1string在父对象中必填
  • format: "uuid"
  • pattern: "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
content.project_idanyOf 2null在父对象中必填—
完整 JSON Schema
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "object",
  "properties": {
    "workspace_id": {
      "type": "string",
      "format": "uuid",
      "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
    },
    "mutation_id": {
      "type": "string",
      "format": "uuid",
      "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
    },
    "id": {
      "type": "string",
      "format": "uuid",
      "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
    },
    "expected_revision": {
      "type": "integer",
      "exclusiveMinimum": 0,
      "maximum": 9007199254740991
    },
    "content": {
      "type": "object",
      "properties": {
        "title": {
          "type": "string",
          "minLength": 1,
          "maxLength": 200
        },
        "notes": {
          "type": "string",
          "maxLength": 10000
        },
        "audience": {
          "type": "string",
          "maxLength": 2000
        },
        "angle": {
          "type": "string",
          "maxLength": 2000
        },
        "tags": {
          "maxItems": 20,
          "type": "array",
          "items": {
            "type": "string",
            "minLength": 1,
            "maxLength": 60
          }
        },
        "evidence": {
          "maxItems": 500,
          "type": "array",
          "items": {
            "type": "object",
            "properties": {
              "evidence_id": {
                "type": "string",
                "format": "uuid",
                "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
              },
              "revision": {
                "type": "integer",
                "exclusiveMinimum": 0,
                "maximum": 9007199254740991
              }
            },
            "required": [
              "evidence_id",
              "revision"
            ],
            "additionalProperties": false
          }
        },
        "project_id": {
          "anyOf": [
            {
              "type": "string",
              "format": "uuid",
              "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
            },
            {
              "type": "null"
            }
          ]
        }
      },
      "required": [
        "title",
        "notes",
        "audience",
        "angle",
        "tags",
        "evidence",
        "project_id"
      ],
      "additionalProperties": false
    }
  },
  "required": [
    "workspace_id",
    "mutation_id",
    "id",
    "expected_revision",
    "content"
  ],
  "additionalProperties": false
}

响应与完成

成功 HTTP 状态:200。操作完成时: committed Research resource version; no provider action.

成功 HTTP 响应可能表示请求已接受,并非已完成。背景工作请存储返回 ID,持续检查同一操作直到完成。已排程或已接受的帖子,只有平台确认后才算已发布;客户端逾时无法证明结果。

「必填」是指在其父对象及所选分支内必填。必填子字段不会使可选父对象变成必填。下列规则与字段名称均复制自契约。

响应与完成
字段 / 分支类型 / 必填约束
$object在父对象中必填—
ideaobject在父对象中必填—
idea.idstring在父对象中必填
  • format: "uuid"
  • pattern: "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
idea.workspace_idstring在父对象中必填
  • format: "uuid"
  • pattern: "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
idea.revisioninteger在父对象中必填
  • maximum: 9007199254740991
  • exclusiveMinimum: 0
idea.archivedboolean在父对象中必填—
idea.created_atstring在父对象中必填
  • format: "date-time"
  • pattern: "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z|([+-](?:[01]\\d|2[0-3]):[0-5]\\d)))$"
idea.updated_atstring在父对象中必填
  • format: "date-time"
  • pattern: "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z|([+-](?:[01]\\d|2[0-3]):[0-5]\\d)))$"
idea.contentobject在父对象中必填—
idea.content.titlestring在父对象中必填
  • minLength: 1
  • maxLength: 200
idea.content.notesstring在父对象中必填
  • maxLength: 10000
idea.content.audiencestring在父对象中必填
  • maxLength: 2000
idea.content.anglestring在父对象中必填
  • maxLength: 2000
idea.content.tagsarray在父对象中必填
  • maxItems: 20
idea.content.tags[]string可选/项目
  • minLength: 1
  • maxLength: 60
idea.content.evidencearray在父对象中必填
  • maxItems: 500
idea.content.evidence[]object可选/项目—
idea.content.evidence[].evidence_idstring在父对象中必填
  • format: "uuid"
  • pattern: "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
idea.content.evidence[].revisioninteger在父对象中必填
  • maximum: 9007199254740991
  • exclusiveMinimum: 0
idea.content.project_idstring | null在父对象中必填—
idea.content.project_idanyOf 1string在父对象中必填
  • format: "uuid"
  • pattern: "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
idea.content.project_idanyOf 2null在父对象中必填—
完整 JSON Schema
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "object",
  "properties": {
    "idea": {
      "type": "object",
      "properties": {
        "id": {
          "type": "string",
          "format": "uuid",
          "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
        },
        "workspace_id": {
          "type": "string",
          "format": "uuid",
          "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
        },
        "revision": {
          "type": "integer",
          "exclusiveMinimum": 0,
          "maximum": 9007199254740991
        },
        "archived": {
          "type": "boolean"
        },
        "created_at": {
          "type": "string",
          "pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z|([+-](?:[01]\\d|2[0-3]):[0-5]\\d)))$",
          "format": "date-time"
        },
        "updated_at": {
          "type": "string",
          "pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z|([+-](?:[01]\\d|2[0-3]):[0-5]\\d)))$",
          "format": "date-time"
        },
        "content": {
          "type": "object",
          "properties": {
            "title": {
              "type": "string",
              "minLength": 1,
              "maxLength": 200
            },
            "notes": {
              "type": "string",
              "maxLength": 10000
            },
            "audience": {
              "type": "string",
              "maxLength": 2000
            },
            "angle": {
              "type": "string",
              "maxLength": 2000
            },
            "tags": {
              "maxItems": 20,
              "type": "array",
              "items": {
                "type": "string",
                "minLength": 1,
                "maxLength": 60
              }
            },
            "evidence": {
              "maxItems": 500,
              "type": "array",
              "items": {
                "type": "object",
                "properties": {
                  "evidence_id": {
                    "type": "string",
                    "format": "uuid",
                    "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
                  },
                  "revision": {
                    "type": "integer",
                    "exclusiveMinimum": 0,
                    "maximum": 9007199254740991
                  }
                },
                "required": [
                  "evidence_id",
                  "revision"
                ]
              }
            },
            "project_id": {
              "anyOf": [
                {
                  "type": "string",
                  "format": "uuid",
                  "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
                },
                {
                  "type": "null"
                }
              ]
            }
          },
          "required": [
            "title",
            "notes",
            "audience",
            "angle",
            "tags",
            "evidence",
            "project_id"
          ]
        }
      },
      "required": [
        "id",
        "workspace_id",
        "revision",
        "archived",
        "created_at",
        "updated_at",
        "content"
      ]
    }
  },
  "required": [
    "idea"
  ]
}

错误与安全重试

检查 HTTP 状态和响应正文。400 验证错误可能包含 ZodError;处理程序错误使用 error、message 和 code 字段。保留 request_id 或 x-request-id 以便诊断,但不要保留凭证。先解决 401/403 访问错误再重试,并在收到 429 时遵循 Retry-After。如写入结果不确定或返回 5xx,先读取现有结果。仅在支持时复用幂等键;重试行为因操作而异,并不保证恰好交付一次。

故障排查指南

示例

这些示例使用已依schema检查的虚构值。请将 ID 替换为你有权使用的 ID、将媒体替换为已就绪素材,并将日期替换为已确认的发布时间。提交写入前,请检查账号资格。本页不会发送 API 请求。

在服务器上将 SOSOAPI_ACCESS_TOKEN 设为此操作接受的凭证,且不要放入浏览器代码。AI 智能代理 请使用 sosoapi auth login 通过浏览器登录,并由 CLI 更新凭证。

request.json

{
  "workspace_id": "11111111-1111-4111-8111-111111111111",
  "mutation_id": "11111111-1111-4111-8111-111111111111",
  "id": "11111111-1111-4111-8111-111111111111",
  "expected_revision": 1,
  "content": {
    "title": "example",
    "notes": "example",
    "audience": "example",
    "angle": "example",
    "tags": [],
    "evidence": [],
    "project_id": null
  }
}

cURL

curl --request POST \
  "https://gqeshlawtcexsapabaui.supabase.co/functions/v1/research-api/ideas/update" \
  -H "Authorization: Bearer $SOSOAPI_ACCESS_TOKEN" \
  -H "Content-Type: application/json" \
  --data-binary @request.json

JavaScript

// Server-side JavaScript. Do not print tokens or credential-bearing responses.
const token = process.env.SOSOAPI_ACCESS_TOKEN;
if (!token) throw new Error("Set an accepted credential for this operation");
const response = await fetch("https://gqeshlawtcexsapabaui.supabase.co/functions/v1/research-api/ideas/update", {
  method: "POST",
  headers: { "Content-Type": "application/json", Authorization: "Bearer " + token },
  body: JSON.stringify({
  "workspace_id": "11111111-1111-4111-8111-111111111111",
  "mutation_id": "11111111-1111-4111-8111-111111111111",
  "id": "11111111-1111-4111-8111-111111111111",
  "expected_revision": 1,
  "content": {
    "title": "example",
    "notes": "example",
    "audience": "example",
    "angle": "example",
    "tags": [],
    "evidence": [],
    "project_id": null
  }
})
});
const result = await response.json();
// Check response.ok, the operation-specific body and completion state before continuing.

CLI

npx sosoapi api post /research-api/ideas/update < request.json

合成响应示例

{
  "idea": {
    "id": "11111111-1111-4111-8111-111111111111",
    "workspace_id": "11111111-1111-4111-8111-111111111111",
    "revision": 1,
    "archived": false,
    "created_at": "2099-01-15T09:00:00Z",
    "updated_at": "2099-01-15T09:00:00Z",
    "content": {
      "title": "example",
      "notes": "example",
      "audience": "example",
      "angle": "example",
      "tags": [],
      "evidence": [],
      "project_id": null
    }
  }
}

MCP: sosoapi_research_ideas_update